
/*
	music-usb
				for ForCy-USB
*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>


//	̋Ȃł傤H
static char PROGMEM music[] = "fhjfmmmjhhmmhhfcjjjfeee   cceefhaaffhjkkkjhfhhh   fhjfmmmjhhmmhhfcccefaaa   cceefhaaffhjkkkjhffff   jkm m m m momkj j j j jkjhf f fec e efh hjhjh    jkm m m m momkj j j jkjhfec cefha f hjhhh hffff   ";

static char PROGMEM tone[] = "\x8d\x85\x7e\x76\x70\x69\x63\x5e\x59\x54\x4f\x4a\x46\x42\x3e\x3b\x37\x34\x31\x2e";


static unsigned char	wait, i, off;


ISR( TIMER0_COMPA_vect )
{
	char	n;

	if( --wait )
		return;
	wait	= 125;				// 250mS Ɏs

	n	= pgm_read_byte(music+i++);
	if( n ) {
		if( n==' ' ) {
			TCCR2A	= 0;			// stop
			off	= 1;
		}
		else {
			OCR2A	= pgm_read_byte(tone+n-'a');
			if( off ) {
				TCCR2A	= 0x12;		// start
				off	= 0;
			}
		}
	}
	else
		i	= 0;				// JԂ
}


static void timer_init()
{

	OCR0A   = 249;          // 2mS
	TCCR0A  = 2;
	TCCR0B  = 3;            // 1/64
	TIMSK0  |= (1<<OCIE0A);

	DDRD	= 0xfa;			// PORTD3iOC2Bój
	TCCR2B	= 0x44;
	TCCR2A	= 0x12;
}


int main(void)
{

	wdt_enable(WDTO_15MS);
    timer_init();

	wait	= 0;
	i		= 0;
	off		= 0;

    sei();
    for(;;)
    	wdt_reset();

    return 0;
}

